import java.awt.*;
import java.awt.event.*;

class ClientInfoPanel extends Panel {
    private Insets mInsets                 = new Insets(3,3,3,3);
    private Label       infoUserLabel;
    private Label       infoPasswordLabel;
    private Label       infoCPasswordLabel;
    private Label       infoNameLabel;
    private Label       infoOrgLabel;
    private Label       infoEmailLabel;
    public  TextField   infoUserField;
    public  TextField   infoPasswordField;
    public  TextField   infoCPasswordField;
    public  TextField   infoNameField;
    public  TextField   infoOrgField;
    public  TextField   infoEmailField;
    private Button      infoButton;
    private Button      clearButton;
    private GridBagLayout gb = new GridBagLayout();
    private GridBagConstraints gbc = new GridBagConstraints();
    private int row = 0;
    private ActionListener al;

    public ClientInfoPanel (ActionListener a) {
        al = a;

        setBackground(Color.lightGray);
        setLayout(gb);

        gbc.anchor      = GridBagConstraints.CENTER;
        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        gbc.gridx       = 0;
        gbc.gridy       = row;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        infoUserLabel = makeLabel("Account: ", 12, 1);

        gbc.gridx       = 1;
        infoUserField = makeTextField("", false);

        row += 1;

        gbc.gridx       = 0;
        infoPasswordLabel = makeLabel("Password: ", 12, 1);

        gbc.gridx       = 1;
        infoPasswordField = makeTextField("", true);

        row += 1;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        infoCPasswordLabel = makeLabel("Confirm Password: ", 12, 1);

        gbc.gridx       = 1;
        infoCPasswordField = makeTextField("", true);

        row += 1;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        infoNameLabel = makeLabel("Name: ", 12, 1);

        gbc.gridx       = 1;
        infoNameField = makeTextField("", false);

        row += 1;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        infoOrgLabel = makeLabel("Organization: ", 12, 1);

        gbc.gridx       = 1;
        infoOrgField = makeTextField("", false);

        row += 1;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        infoEmailLabel = makeLabel("Email: ", 12, 1);

        gbc.gridx       = 1;
        infoEmailField = makeTextField("", false);

        row += 3;

        gbc.gridx       = 0;
        infoButton = makeButton("Register");

        gbc.gridx       = 1;
        clearButton = makeButton("Clear");

    }

    protected
    TextField  makeTextField(String name,
                             boolean passwd) {

        gbc.gridy = row;
        TextField field = new TextField(30);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(al);
        gb.setConstraints(field, gbc);
        add(field);

        return field;
    }

    protected
    Label makeLabel(String name,
                    int size,
                    int position) {

        gbc.gridy = row;
        Label label;
        if (position == 0) {
            label = new Label(name, Label.CENTER);
        } else {
            label = new Label(name, Label.RIGHT);
        }

        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gb.setConstraints(label, gbc);
        add(label);

        return label;
    }

    protected
    Button makeButton(String name) {

        gbc.gridy = row;
        Button button = new Button(name);
        button.addActionListener(al);
        gb.setConstraints(button, gbc);
        add(button);

        return button;
    }

    public Insets
    getInsets()
    {
        return mInsets;
    }

    public String
    getUsername() {
        return infoUserField.getText().toUpperCase();
    }

    public String
    getPassword() {
        return infoPasswordField.getText();
    }

    public String
    getCPassword() {
        return infoCPasswordField.getText();
    }

    public String
    getName() {
        return infoNameField.getText();
    }

    public String
    getOrganization() {
        return infoOrgField.getText();
    }

    public String
    getEmail() {
        return infoEmailField.getText();
    }

    public void
    clear() {
        infoUserField.setText("");
        infoPasswordField.setText("");
        infoCPasswordField.setText("");
        infoNameField.setText("");
        infoOrgField.setText("");
        infoEmailField.setText("");
    }
}
